// Global variables
var stage_multiplier = new Array();
stage_multiplier[0] = 1;
var i = 0;
for (i = 1; i <= 6; i++) {
	stage_multiplier[i] = (i + 2) / 2;
	stage_multiplier[-i] = 2 / (i + 2);
}
var nature_labels = ["hindering", "neutral", "helpful"];

function calc_stat(base, ev, iv, level, stage, nature, mult) {
	return Math.floor(Math.floor((iv + 2 * base + Math.floor(ev / 4)) * level / 100 + 5) * nature * stage_multiplier[stage] * mult);
}

function calc_hp(base, ev, iv, level) {
	return Math.floor((iv + 2 * base + Math.floor(ev / 4) + 100) * level / 100) + 10;
}

// jQuery stuff
$(function() {
	$("#attacker_select").buttonset();
	$("#attacker_level_slider").slider({
		value: 100,
		min: 1,
		max: 100,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("attacker_level_value").innerHTML = "Level " + ui.value;
			attack_level = ui.value;
			update_attack_stats();
		}
	});
	$("#attacker_attack_ev_slider").slider({
		value: 0,
		min: 0,
		max: 255,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("attacker_attack_ev_value").innerHTML = "Attack EV: " + ui.value;
			attack_ev = ui.value;
			update_attack_stats();
		}
	});
	$("#attacker_attack_iv_slider").slider({
		value: 0,
		min: 0,
		max: 31,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("attacker_attack_iv_value").innerHTML = "Attack IV: " + ui.value;
			attack_iv = ui.value;
			update_attack_stats();
		}
	});
	$("#attacker_attack_stage_slider").slider({
		value: 0,
		min: -6,
		max: 6,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("attacker_attack_stage_value").innerHTML = "Attack stage: " + ui.value;
			attack_stage = ui.value;
			update_attack_stats();
		}
	});
	$("#attacker_attack_nature_slider").slider({
		value: 1,
		min: 0,
		max: 2,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("attacker_attack_nature_value").innerHTML = "Nature: " + nature_labels[ui.value];
			attack_nature = (ui.value + 9) / 10;
			update_attack_stats();
		}
	});
	$("#consecutive_hits_slider").slider({
		value: 1,
		min: 1,
		max: 5,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("consecutive_hits_value").innerHTML = "Consecutive hits: " + ui.value;
			consecutive_hits = ui.value;
			update_damage();
		}
	});
	
	$("#defender_select").buttonset();
	$("#defender_level_slider").slider({
		value: 100,
		min: 1,
		max: 100,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_level_value").innerHTML = "Level " + ui.value;
			defense_level = ui.value;
			update_defense_stats();
		}
	});
	$("#defender_defense_ev_slider").slider({
		value: 0,
		min: 0,
		max: 255,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_defense_ev_value").innerHTML = "Defense EV: " + ui.value;
			defense_ev = ui.value;
			update_defense_stats();
		}
	});
	$("#defender_defense_iv_slider").slider({
		value: 0,
		min: 0,
		max: 31,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_defense_iv_value").innerHTML = "Defense IV: " + ui.value;
			defense_iv = ui.value;
			update_defense_stats();
		}
	});
	$("#defender_defense_stage_slider").slider({
		value: 0,
		min: -6,
		max: 6,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_defense_stage_value").innerHTML = "Defense stage: " + ui.value;
			defense_stage = ui.value;
			update_defense_stats();
		}
	});
	$("#defender_defense_nature_slider").slider({
		value: 1,
		min: 0,
		max: 2,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_defense_nature_value").innerHTML = "Nature: " + nature_labels[ui.value];
			defense_nature = (ui.value + 9) / 10;
			update_defense_stats();
		}
	});
	$("#defender_hp_ev_slider").slider({
		value: 0,
		min: 0,
		max: 255,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_hp_ev_value").innerHTML = "HP EV: " + ui.value;
			hp_ev = ui.value;
			update_defense_stats();
		}
	});
	$("#defender_hp_iv_slider").slider({
		value: 0,
		min: 0,
		max: 31,
		step: 1,
		slide: function(event, ui) {
			document.getElementById("defender_hp_iv_value").innerHTML = "HP IV: " + ui.value;
			hp_iv = ui.value;
			update_defense_stats();
		}
	});
});

// Attacker
var attackers = ["Solrock", "Lunatone", "Chansey"];
var base_attacks = [95, 55, 5];
var attack_level = 100;
var attack_base = 95;
var attack_ev = 0;
var attack_iv = 0;
var attack_stage = 0;
var attack_nature = 1;
var attack_stat_multiplier = 1;
var consecutive_hits = 1;
var attacker_index = 0;
var attacker_img_urls = ["http://cdn.bulbagarden.net/media/upload/thumb/9/90/338Solrock.png/180px-338Solrock.png", "http://cdn.bulbagarden.net/media/upload/thumb/e/eb/337Lunatone.png/150px-337Lunatone.png", "http://cdn.bulbagarden.net/media/upload/c/cd/113Chansey.png"];
function choose_attacker(index) {
	if (index == 2) {
		document.getElementById("attacker").className = "normal";
		document.getElementById("attack_defense_curl").disabled = false;
	} else {
		document.getElementById("attacker").className = "rock_psychic";
		document.getElementById("attack_defense_curl").checked = false;
		document.getElementById("attack_defense_curl").disabled = true;
	}
	document.getElementById("attacker_image").src = attacker_img_urls[index];
	attack_base = base_attacks[index];
	attacker_index = index;
	update_attack_stats();
}
function update_attack_stats() {
	var item = document.getElementById("attack_stats");
	item.innerHTML = "Level " + attack_level + " " + attackers[attacker_index] + "<br />Base attack: " + attack_base + "<br />Effective attack stat: " + calc_stat(attack_base, attack_ev, attack_iv, attack_level, attack_stage, attack_nature, attack_stat_multiplier);
	update_damage();
}

function update_cherrim() {
	if (document.getElementById("attack_cherrim").checked) {
		attack_stat_multiplier *= 1.5;
	} else {
		attack_stat_multiplier /= 1.5;
	}
	update_attack_stats();
}
function update_choice_band() {
	if (document.getElementById("attack_choice_band").checked) {
		attack_stat_multiplier *= 1.5;
	} else {
		attack_stat_multiplier /= 1.5;
	}
	update_attack_stats();
}
function update_pure_power() {
	if (document.getElementById("attack_pure_power").checked) {
		attack_stat_multiplier *= 2;
	} else {
		attack_stat_multiplier /= 2;
	}
	update_attack_stats();
}

function update_critical() {
	if (document.getElementById("attack_critical").checked) {
		if ($("#attacker_attack_stage_slider").slider("option", "value") < 0) {
			$("#attacker_attack_stage_slider").slider("option", "value", 0);
		}
		if ($("#defender_defense_stage_slider").slider("option", "value") > 0) {
			$("#defender_defense_stage_slider").slider("option", "value", 0);
		}
		$("#attacker_attack_stage_slider").slider("option", "min", 0);
		$("#defender_defense_stage_slider").slider("option", "max", 0);
	} else {
		$("#attacker_attack_stage_slider").slider("option", "min", -6);
		$("#defender_defense_stage_slider").slider("option", "max", 6);
	}
	$("#attacker_attack_stage_slider").slider("option", "value", $("#attacker_attack_stage_slider").slider("option", "value"));
	$("#defender_defense_stage_slider").slider("option", "value", $("#defender_defense_stage_slider").slider("option", "value"));
	document.getElementById("attacker_attack_stage_value").innerHTML = "Attack stage: " + $("#attacker_attack_stage_slider").slider("option", "value");
	attack_stage = $("#attacker_attack_stage_slider").slider("option", "value");
	update_attack_stats();
	document.getElementById("defender_defense_stage_value").innerHTML = "Defense stage: " + $("#defender_defense_stage_slider").slider("option", "value");
	defense_stage = $("#defender_defense_stage_slider").slider("option", "value");
	update_defense_stats();
}

// Defender
var defenders = ["Charizard", "Moltres"];
var base_defenses = [78, 90];
var base_hps = [78, 90];
var defense_level = 100;
var defense_base = 78;
var defense_ev = 0;
var defense_iv = 0;
var defense_stage = 0;
var defense_nature = 1;
var hp_base = 78;
var hp_ev = 0;
var hp_iv = 0;
var defender_index = 0;
var defender_img_urls = ["http://cdn.bulbagarden.net/media/upload/thumb/7/7e/006Charizard.png/230px-006Charizard.png", "http://cdn.bulbagarden.net/media/upload/thumb/1/1b/146Moltres.png/300px-146Moltres.png"];
function choose_defender(index) {
	document.getElementById("defender_image").src = defender_img_urls[index];
	defense_base = base_defenses[index];
	hp_base = base_hps[index];
	defender_index = index;
	update_defense_stats();
}
function update_defense_stats() {
	var item = document.getElementById("defense_stats");
	item.innerHTML = "Level " + defense_level + " " + defenders[defender_index] + "<br />Base defense: " + defense_base + "<br />Effective defense stat: " + calc_stat(defense_base, defense_ev, defense_iv, defense_level, defense_stage, defense_nature, 1) + "<br />Base HP: " + hp_base + "<br />Maximum HP: " + calc_hp(hp_base, hp_ev, hp_iv, defense_level, 1);
	update_damage();
}

function update_damage() {
	// Attack stat
	var atk = calc_stat(attack_base, attack_ev, attack_iv, attack_level, attack_stage, attack_nature, attack_stat_multiplier);
	
	// Defense stat
	var def = calc_stat(defense_base, defense_ev, defense_iv, defense_level, defense_stage, defense_nature, 1);
	
	// Attack base power
	var base = 30 * Math.pow(2, consecutive_hits - 1);
	// Helping Hand
	if (document.getElementById("attack_helping_hand").checked) {
		base *= 1.5;
	}
	// Defense Curl
	if (document.getElementById("attack_defense_curl").checked) {
		base *= 2;
	}
	document.getElementById("base_power_text").innerHTML = "<br />Base power: " + Math.round(base)
	
	// Base damage
	var dmg = (2 * attack_level + 10) * atk * base / (250 * def) + 2;
	// Rollout is doubly super effective against Fire-Flying types
	dmg *= 4;
	// Solrock and Lunatone benefit from the STAB
	if (attacker_index != 2) {
		dmg *= 1.5;
	}
	// Critical hits
	if (document.getElementById("attack_critical").checked) {
		dmg *= 2;
	}
	
	// Randomization
	var low = Math.floor(dmg * 0.85);
	var high = Math.floor(dmg);
	
	document.getElementById("damage").innerHTML = "Damage: " + low + "&ndash;" + high;
}

// Set defaults on page load
window.onload = function() {
	choose_attacker(0);
	choose_defender(0);
};